/* pJ^Ji@ˑ`FbNvO HK.C */
/* Ver 1.0 - 1997/8/1 by "P.MAKINO" <pmakino@sfc.ne.jp> */
/* based on HK.C by i v <syouji@nnc.or.jp> */

#include <stdio.h>

#define ERR01 0x0001  /* Rg[R[h */
#define ERR02 0x0002  /* pJ^Ji */
#define ERR03 0x0004  /* 1byteڈُ */
#define ERR04 0x0008  /* 2byteڈُ */

int sjisctrl(unsigned char incod) {
  if( (incod <= 0x08) || (incod == 0x0b)
   ||((incod >= 0x0e) && (incod <= 0x1f))
   || (incod == 0x7f) || (incod == 0x80)
   || (incod == 0xa0) || (incod == 0xfd)
   || (incod == 0xfe) || (incod == 0xff) ) return 1;
  else return 0;
}

int sjisprta(unsigned char incod) {
  if( ((incod >= 0x20) && (incod <= 0x7e))
    || (incod == 0x0d) || (incod == 0x0a)
    || (incod == 0x09) || (incod == 0x0c) ) return 1;
  else return 0;
}

int sjiskana(unsigned char incod) {
  if( (incod >= 0xa1) && (incod <= 0xdf) ) return 1;
  else return 0;
}

int sjisknj1(unsigned char incod) {
  if( ((incod >= 0x81) && (incod <= 0x84))
   || ((incod >= 0x88) && (incod <= 0x9f))
   || ((incod >= 0xe0) && (incod <= 0xea)) ) return 1;
  else return 0;
}

int sjisknj2(unsigned char incod) {
  if( (incod > 0x39) && (incod < 0xfd) ) return 1;
  else return 0;
}

int sjisknje(unsigned char incd1, unsigned char incd2) {
  if(incd1 == 0x81) {
    if((0xad <= incd2) && (incd2 <= 0xb7)
    || (0xc0 <= incd2) && (incd2 <= 0xc7)
    || (0xcf <= incd2) && (incd2 <= 0xd9)
    || (0xe9 <= incd2) && (incd2 <= 0xef)
    || (0xf8 <= incd2) && (incd2 <= 0xfb)) return 1;
  } else if(incd1 == 0x82) {
    if((0x3f <= incd2) && (incd2 <= 0x4e)
    || (0x59 <= incd2) && (incd2 <= 0x5f)
    || (0x7a <= incd2) && (incd2 <= 0x7f)
    || (0x9b <= incd2) && (incd2 <= 0x9e)
    || (0xf2 <= incd2) && (incd2 <= 0xfc)) return 1;
  } else if(incd1 == 0x83) {
    if((0x97 <= incd2) && (incd2 <= 0x9e)
    || (0xb7 <= incd2) && (incd2 <= 0xbe)
    || (0xd7 <= incd2) && (incd2 <= 0xfc)) return 1;
  } else if(incd1 == 0x84) {
    if((0x61 <= incd2) && (incd2 <= 0x6f)
    || (0x92 <= incd2) && (incd2 <= 0x9e)
    || (0xbf <= incd2) && (incd2 <= 0xfc)) return 1;
  } else if(incd1 == 0x98) {
    if((0x73 <= incd2) && (incd2 <= 0x9e)) return 1;
  } else if(incd1 == 0xea) {
    if((0xa5 <= incd2) && (incd2 <= 0xfc)) return 1;
  }
  return 0;
}

int padcheck(FILE *fpi, FILE *fpo) {
  int retcd;
  int knj_f, kana;
  unsigned int lcnt;
  unsigned char buf[4];
  unsigned char in_char;
  int fgetcprev, fgetcbuf, fgetc_f; /* ^1߂Ȃǂ邽 */

  lcnt = 1;
  retcd = 0;
  fgetc_f = 0;
  kana = 0;
  knj_f = 0;
  while(1) {
    if(fgetc_f) {
      fgetc_f = 0;
    } else {
      fgetcprev = fgetcbuf; fgetcbuf = fgetc(fpi);
    }
    if(fgetcbuf == EOF) break;
    in_char = (unsigned char)fgetcbuf;

    if(knj_f == 0) {
      if(sjiskana(in_char)) {
        retcd |= ERR02; /* half size kana : error */
        if(kana == 0) {
          kana++;
          fprintf(fpo, "Line %04u: pJi \"", lcnt);
        }
        fprintf(fpo, "%c", in_char);
      } else {
        if(kana) { kana = 0; fprintf(fpo, "\" ܂܂Ă܂B\n"); }
        if(in_char == 0x0d) {
        } else if(in_char == 0x0a) {
          lcnt++;
        } else if(sjisctrl(in_char)) {
          retcd |= ERR01; /* control code : error */
          fprintf(fpo, "Line %04u: sK؂ȃRg[R[h 0x%02X ܂܂Ă܂B\n", lcnt, in_char);
        } else if(sjisprta(in_char)) { /* printable character */
        } else if(sjisknj1(in_char)) {
          knj_f = 1; /* kanji first */
        } else {
          knj_f = 1; /* kanji first */
          retcd |= ERR03; /* kanji first : error */
          buf[0] = in_char;
          fgetcprev = fgetcbuf; fgetcbuf = fgetc(fpi); fgetc_f = 1;
          buf[1] = (unsigned char)fgetcbuf;
          buf[2] = 0;
          fprintf(fpo, "Line %04u: @ˑƎv镶 \"%s\" ܂܂Ă܂B(0x%02X%02X)\n", lcnt, buf, buf[0], buf[1]);
        }
      }
    } else {
      knj_f = 0; /* kanji second */
      if((sjisknj2(in_char))) {
        if(sjisknje((unsigned char)fgetcprev, in_char)) {
          buf[0] = (unsigned char)fgetcprev;
          buf[1] = in_char;
          buf[2] = 0;
          fprintf(fpo, "Line %04u: @ˑƎv镶 \"%s\" ܂܂Ă܂B(0x%02X%02X)\n", lcnt, buf, buf[0], buf[1]);
        }
      } else {
        retcd |= ERR04; /* kanji second : error */
        fprintf(fpo, "Line %04u: 2byteڂƂĕsK؂ȃR[h 0x%02X ܂܂Ă܂B\n", lcnt, in_char);
      }
      if(in_char == 0x0a) lcnt++; /* ꉞsԍ͑₵Ă݂ */
    }
  }
  fprintf(fpo, "\n");
  return retcd;
}

int main(int argc, char *argv[]) {
  int cnt;
  FILE *fpi, *fpo;

  fpo = stdout; /* o͕͐Wo͂ */
  if(argc == 1) { /* t@Cw肳ĂȂꍇ͕W͂ */
    fpi = stdin;
    fprintf(fpo, "[stdin]\n");
    if(padcheck(fpi, fpo)) fprintf(fpo, "\n");
  } else { /* t@Cw肳Ă΂() */
    for(cnt = 1; cnt < argc; cnt++) {
      if((argv[cnt][0] == '-' || argv[cnt][0] == '/')
      && (argv[cnt][1] == 'h' || argv[cnt][1] == '?')) {
        fprintf(stdout, "HK - pJ^Ji@ˑ`FbNvO\nusage: HK infile1 infile2 ...\n       HK < infile > outfile\n");
        return 0;
      }
    }
    for(cnt = 1; cnt < argc; cnt++) {
      fpi = fopen(argv[cnt], "rb");
      if(fpi == NULL) {
        fprintf(fpo, "can't open:[%s]\n", argv[cnt]);
        continue;
      } else {
        fprintf(fpo, "filename:[%s]\n", argv[cnt]);
        padcheck(fpi, fpo);
        fclose(fpi);
      }
    }
  }
  return 0;
}
